#ident "$Id: dbase.c,v 1.2 2004/01/26 23:43:21 dtynan Exp $"

/*
 * $Id: dbase.c,v 1.2 2004/01/26 23:43:21 dtynan Exp $
 *
 * Copyright (c) 2003, Kalopa Media Limited.  All rights reserved.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * It is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this product; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * THIS SOFTWARE IS PROVIDED BY KALOPA MEDIA LIMITED "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL KALOPA MEDIA LIMITED BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ABSTRACT
 *
 * $Log: dbase.c,v $
 * Revision 1.2  2004/01/26 23:43:21  dtynan
 * Extensive changes to fix some M4 issues and some library issues.
 * Removed many of the functions which were used to parse data types
 * and made them inline instead.  Improved the M4 generator by adding
 * for loops.
 *
 * Revision 1.1  2003/10/14 13:00:21  dtynan
 * Major revision of the DBOW code to use M4 as a back-end instead of
 * hard-coding the output.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#ifdef DBOW_MYSQL
#include "mysql.h"
#endif

#include "dbow.h"

/*
 *
 */
dbow_conn *
dbow_init(char *host, char *user, char *pwd, char *dbase)
{
	dbow_conn *conn;

	conn = (dbow_conn *)malloc(sizeof(dbow_conn));
	if (conn == NULL)
		return(NULL);
	if ((conn->dbconn = (void *)mysql_init(NULL)) == NULL ||
				mysql_real_connect(conn->dbconn,
				host, user, pwd, dbase, 0, NULL, 0) == NULL) {
		free((void *)conn);
		return(NULL);
	}
	conn->qbuff = NULL;
	conn->qboff = conn->qbsize = 0;
	return(conn);
}

/*
 *
 */
void
dbow_close(dbow_conn *conn)
{
	mysql_close(conn->dbconn);
	if (conn->qbuff != NULL)
		free(conn->qbuff);
	free((void *)conn);
}
